package nc.bs.riart.pfxx;
import nc.bs.dao.BaseDAO;
import nc.bs.framework.common.NCLocator;
import nc.itf.uap.IUAPQueryBS;
import nc.jdbc.framework.processor.ColumnProcessor;

public class GetBaseDAOUtil {
    private static IUAPQueryBS iuap = NCLocator.getInstance().lookup(IUAPQueryBS.class);

    // 用户编码
    public static String getUserCode(String cuserid) throws Exception {
        String sql = "select user_code from sm_user where cuserid ='"+cuserid+"' and nvl(dr,0)=0";
        String user_code = (String) iuap.executeQuery(sql, new ColumnProcessor());
        if (user_code == null) {
            return "";
        }
        return user_code;
    }

    //用户名称
    public static String getUserName(String cuserid) throws Exception {
        String sql = "select user_name from sm_user where cuserid ='"+cuserid+"' and nvl(dr,0)=0";
        String user_name = (String) iuap.executeQuery(sql, new ColumnProcessor());
        if (user_name == null) {
            return "";
        }
        return user_name;
    }

    //凭证类别编码
    public static String getVoucherTypeCode(String pk_vouchertype) throws Exception {
        String sql = "select code from bd_vouchertype where pk_vouchertype ='"+pk_vouchertype+"' and nvl(dr,0)=0";
        String vouchertypecode = (String) iuap.executeQuery(sql, new ColumnProcessor());
        if (vouchertypecode == null) {
            return "";
        }
        return vouchertypecode;
    }

    //凭证类别名称
    public static String getVoucherTypeName(String pk_vouchertype) throws Exception {
        String sql = "select name from bd_vouchertype where pk_vouchertype ='"+pk_vouchertype+"' and nvl(dr,0)=0";
        String vouchertypename = (String) iuap.executeQuery(sql, new ColumnProcessor());
        if (vouchertypename == null) {
            return "";
        }
        return vouchertypename;
    }

    //财务组织编码
    public static String getOrgCode(String pk_org) throws Exception {
        String sql = "select code from org_financeorg where pk_financeorg ='"+pk_org+"' and nvl(dr,0)=0";
        String code = (String) iuap.executeQuery(sql, new ColumnProcessor());
        if (code == null) {
            return "";
        }
        return code;
    }

    //财务组织名称
    public static String getOrgName(String pk_org) throws Exception {
        String sql = "select name from org_financeorg where pk_financeorg ='"+pk_org+"' and nvl(dr,0)=0";
        String name = (String) iuap.executeQuery(sql, new ColumnProcessor());
        if (name == null) {
            return "";
        }
        return name;
    }

    //账簿编码
    public static String getAccountBookCode(String pk_accountingbook) throws Exception {
        String sql = "select code from org_accountingbook where pk_accountingbook ='"+pk_accountingbook+"' and nvl(dr,0)=0";
        String code = (String) iuap.executeQuery(sql, new ColumnProcessor());
        if (code == null) {
            return "";
        }
        return code;
    }

    //账簿名称
    public static String getAccountBookName(String pk_accountingbook) throws Exception {
        String sql = "select name from org_accountingbook where pk_accountingbook ='"+pk_accountingbook+"' and nvl(dr,0)=0";
        String name = (String) iuap.executeQuery(sql, new ColumnProcessor());
        if (name == null) {
            return "";
        }
        return name;
    }


    //币种
    public static String getCurrencyName(String pk_currtype) throws Exception{
        StringBuffer str = new StringBuffer();
        str.append("select a.name from bd_currtype a ");
        str.append("where a.pk_currtype = '"+pk_currtype+"' and nvl(a.dr,0)=0 ");
        String name = (String) iuap.executeQuery(str.toString(), new ColumnProcessor());
        if (name == null) {
            return "";
        }
        return name;
    }

    //会计科目名称
    public static String getAccountName(String pk_accasoa) throws Exception{
        StringBuffer str = new StringBuffer();
        str.append("select c.name from gl_detail a ");
        str.append("left join bd_accasoa b on a.pk_accasoa = b.pk_accasoa ");
        str.append("left join bd_account c on b.pk_account = c.pk_account ");
        str.append("where a.pk_accasoa = '"+pk_accasoa+"' and nvl(a.dr,0)=0 and nvl(b.dr,0)=0 and nvl(c.dr,0)=0");
        String name = (String) iuap.executeQuery(str.toString(), new ColumnProcessor());
        if (name == null) {
            return "";
        }
        return name;
    }
    
    //辅助核算1 部门编码
    public static String getDeptCode(String pk) throws Exception{
        StringBuffer str = new StringBuffer();
        str.append("select code from org_dept where nvl(dr,0)=0 and pk_dept = '"+pk+"'");
        String code = (String) iuap.executeQuery(str.toString(), new ColumnProcessor());
        if (code == null) {
            return "";
        }
        return code;
    }

    //辅助核算1 部门名称
    public static String getDeptName(String pk) throws Exception{
        StringBuffer str = new StringBuffer();
        str.append("select name from org_dept where nvl(dr,0)=0 and pk_dept = '"+pk+"'");
        String name = (String) iuap.executeQuery(str.toString(), new ColumnProcessor());
        if (name == null) {
            return "";
        }
        return name;
    }
    
    //辅助核算2 人员编码
    public static String getPsnCode(String pk) throws Exception{
        StringBuffer str = new StringBuffer();
        str.append("select code from bd_psndoc where nvl(dr,0)=0 and pk_psndoc = '"+pk+"'");
        String code = (String) iuap.executeQuery(str.toString(), new ColumnProcessor());
        if (code == null) {
            return "";
        }
        return code;
    }
    
    //辅助核算2 人员名称
    public static String getPsnName(String pk) throws Exception{
        StringBuffer str = new StringBuffer();
        str.append("select name from bd_psndoc where nvl(dr,0)=0 and pk_psndoc = '"+pk+"'");
        String name = (String) iuap.executeQuery(str.toString(), new ColumnProcessor());
        if (name == null) {
            return "";
        }
        return name;
    }
    
    //辅助核算3 地区分类编码
    public static String getAreaclCode(String pk) throws Exception{
        StringBuffer str = new StringBuffer();
        str.append("select code from bd_areacl where nvl(dr,0)=0 and pk_areacl = '"+pk+"'");
        String code = (String) iuap.executeQuery(str.toString(), new ColumnProcessor());
        if (code == null) {
            return "";
        }
        return code;
    }
    
    //辅助核算3 地区分类名称
    public static String getAreaclName(String pk) throws Exception{
        StringBuffer str = new StringBuffer();
        str.append("select name from bd_areacl where nvl(dr,0)=0 and pk_areacl = '"+pk+"'");
        String name = (String) iuap.executeQuery(str.toString(), new ColumnProcessor());
        if (name == null) {
            return "";
        }
        return name;
    }
    
    //辅助核算4,5 客商编码
    public static String getCustSupplierCode(String pk) throws Exception{
        StringBuffer str = new StringBuffer();
        str.append("select code from bd_cust_supplier where nvl(dr,0)=0 and pk_cust_sup = '"+pk+"'");
        String code = (String) iuap.executeQuery(str.toString(), new ColumnProcessor());
        if (code == null) {
            return "";
        }
        return code;
    }
    
    //辅助核算4,5 客商名称
    public static String getCustSupplierName(String pk) throws Exception{
        StringBuffer str = new StringBuffer();
        str.append("select name from bd_cust_supplier where nvl(dr,0)=0 and pk_cust_sup = '"+pk+"'");
        String name = (String) iuap.executeQuery(str.toString(), new ColumnProcessor());
        if (name == null) {
            return "";
        }
        return name;
    }
    
    //辅助核算6 物料编码
    public static String getMaterialCode(String pk) throws Exception{
        StringBuffer str = new StringBuffer();
        str.append("select code from bd_material where nvl(dr,0)=0 and pk_material = '"+pk+"'");
        String code = (String) iuap.executeQuery(str.toString(), new ColumnProcessor());
        if (code == null) {
            return "";
        }
        return code;
    }
    
    //辅助核算6 物料名称
    public static String getMaterialName(String pk) throws Exception{
        StringBuffer str = new StringBuffer();
        str.append("select name from bd_material where nvl(dr,0)=0 and pk_material = '"+pk+"'");
        String name = (String) iuap.executeQuery(str.toString(), new ColumnProcessor());
        if (name == null) {
            return "";
        }
        return name;
    }
    
    //辅助核算7 现金流量编码
    public static String getCashFlowCode(String pk) throws Exception{
        StringBuffer str = new StringBuffer();
        str.append("select code from bd_cashflow where nvl(dr,0)=0 and pk_cashflow = '"+pk+"'");
        String code = (String) iuap.executeQuery(str.toString(), new ColumnProcessor());
        if (code == null) {
            return "";
        }
        return code;
    }
    
    //辅助核算7 现金流量名称
    public static String getCashFlowName(String pk) throws Exception{
        StringBuffer str = new StringBuffer();
        str.append("select name from bd_cashflow where nvl(dr,0)=0 and pk_cashflow = '"+pk+"'");
        String name = (String) iuap.executeQuery(str.toString(), new ColumnProcessor());
        if (name == null) {
            return "";
        }
        return name;
    }
    
    //辅助核算8 收支项目编码
    public static String getInOutBusiCode(String pk) throws Exception{
        StringBuffer str = new StringBuffer();
        str.append("select code from bd_inoutbusiclass where nvl(dr,0)=0 and pk_inoutbusiclass = '"+pk+"'");
        String code = (String) iuap.executeQuery(str.toString(), new ColumnProcessor());
        if (code == null) {
            return "";
        }
        return code;
    }
    
    //辅助核算8 收支项目名称
    public static String getInOutBusiName(String pk) throws Exception{
        StringBuffer str = new StringBuffer();
        str.append("select name from bd_inoutbusiclass where nvl(dr,0)=0 and pk_inoutbusiclass = '"+pk+"'");
        String name = (String) iuap.executeQuery(str.toString(), new ColumnProcessor());
        if (name == null) {
            return "";
        }
        return name;
    }
    
    //辅助核算9 资金计划项目编码
    public static String getFundPlanCode(String pk) throws Exception{
        StringBuffer str = new StringBuffer();
        str.append("select code from bd_fundplan where nvl(dr,0)=0 and pk_fundplan = '"+pk+"'");
        String code = (String) iuap.executeQuery(str.toString(), new ColumnProcessor());
        if (code == null) {
            return "";
        }
        return code;
    }
    
    //辅助核算9 资金计划项目名称
    public static String getFundPlanName(String pk) throws Exception{
        StringBuffer str = new StringBuffer();
        str.append("select name from bd_fundplan where nvl(dr,0)=0 and pk_fundplan = '"+pk+"'");
        String name = (String) iuap.executeQuery(str.toString(), new ColumnProcessor());
        if (name == null) {
            return "";
        }
        return name;
    }
    
    //辅助核算10 项目编码
    public static String getProjectCode(String pk) throws Exception{
        StringBuffer str = new StringBuffer();
        str.append("select code from bd_project where nvl(dr,0)=0 and pk_project = '"+pk+"'");
        String code = (String) iuap.executeQuery(str.toString(), new ColumnProcessor());
        if (code == null) {
            return "";
        }
        return code;
    }
    
    //辅助核算10 项目名称
    public static String getProjectName(String pk) throws Exception{
        StringBuffer str = new StringBuffer();
        str.append("select name from bd_project where nvl(dr,0)=0 and pk_project = '"+pk+"'");
        String name = (String) iuap.executeQuery(str.toString(), new ColumnProcessor());
        if (name == null) {
            return "";
        }
        return name;
    }
    
    //辅助核算11 银行账户子户编码
    public static String getBankAccSubCode(String pk) throws Exception{
        StringBuffer str = new StringBuffer();
        str.append("select code from bd_bankaccsub where nvl(dr,0)=0 and pk_bankaccsub = '"+pk+"'");
        String code = (String) iuap.executeQuery(str.toString(), new ColumnProcessor());
        if (code == null) {
            return "";
        }
        return code;
    }
    
    //辅助核算11 银行账户子户名称
    public static String getBankAccSubName(String pk) throws Exception{
        StringBuffer str = new StringBuffer();
        str.append("select name from bd_bankaccsub where nvl(dr,0)=0 and pk_bankaccsub = '"+pk+"'");
        String name = (String) iuap.executeQuery(str.toString(), new ColumnProcessor());
        if (name == null) {
            return "";
        }
        return name;
    }
    
    //辅助核算12 成本中心编码
    public static String getCostCenterCode(String pk) throws Exception{
        StringBuffer str = new StringBuffer();
        str.append("select cccode from resa_costcenter where nvl(dr,0)=0 and pk_costcenter = '"+pk+"'");
        String code = (String) iuap.executeQuery(str.toString(), new ColumnProcessor());
        if (code == null) {
            return "";
        }
        return code;
    }
    
    //辅助核算12 成本中心名称
    public static String getCostCenterName(String pk) throws Exception{
        StringBuffer str = new StringBuffer();
        str.append("select ccname from resa_costcenter where nvl(dr,0)=0 and pk_costcenter = '"+pk+"'");
        String name = (String) iuap.executeQuery(str.toString(), new ColumnProcessor());
        if (name == null) {
            return "";
        }
        return name;
    }
    
    //辅助核算13 客户编码
    public static String getCustomerCode(String pk) throws Exception{
        StringBuffer str = new StringBuffer();
        str.append("select code from bd_customer where nvl(dr,0)=0 and pk_customer = '"+pk+"'");
        String code = (String) iuap.executeQuery(str.toString(), new ColumnProcessor());
        if (code == null) {
            return "";
        }
        return code;
    }
    
    //辅助核算13 客户名称
    public static String getCustomerName(String pk) throws Exception{
        StringBuffer str = new StringBuffer();
        str.append("select name from bd_customer where nvl(dr,0)=0 and pk_customer = '"+pk+"'");
        String name = (String) iuap.executeQuery(str.toString(), new ColumnProcessor());
        if (name == null) {
            return "";
        }
        return name;
    }
    
    //辅助核算14 供应商编码
    public static String getSupplierCode(String pk) throws Exception{
        StringBuffer str = new StringBuffer();
        str.append("select code from bd_supplier where nvl(dr,0)=0 and pk_supplier = '"+pk+"'");
        String code = (String) iuap.executeQuery(str.toString(), new ColumnProcessor());
        if (code == null) {
            return "";
        }
        return code;
    }
    
    //辅助核算14 供应商名称
    public static String getSupplierName(String pk) throws Exception{
        StringBuffer str = new StringBuffer();
        str.append("select name from bd_supplier where nvl(dr,0)=0 and pk_supplier = '"+pk+"'");
        String name = (String) iuap.executeQuery(str.toString(), new ColumnProcessor());
        if (name == null) {
            return "";
        }
        return name;
    }
    
    //辅助核算15 银行类别编码
    public static String getBankTypeCode(String pk) throws Exception{
        StringBuffer str = new StringBuffer();
        str.append("select code from bd_banktype where nvl(dr,0)=0 and pk_banktype = '"+pk+"'");
        String code = (String) iuap.executeQuery(str.toString(), new ColumnProcessor());
        if (code == null) {
            return "";
        }
        return code;
    }
    
    //辅助核算15 银行类别名称
    public static String getBankTypeName(String pk) throws Exception{
        StringBuffer str = new StringBuffer();
        str.append("select name from bd_banktype where nvl(dr,0)=0 and pk_banktype = '"+pk+"'");
        String name = (String) iuap.executeQuery(str.toString(), new ColumnProcessor());
        if (name == null) {
            return "";
        }
        return name;
    }
    
    //辅助核算16 物料分类编码
    public static String getMarBasCode(String pk) throws Exception{
        StringBuffer str = new StringBuffer();
        str.append("select code from bd_marbasclass where nvl(dr,0)=0 and pk_marbasclass = '"+pk+"'");
        String code = (String) iuap.executeQuery(str.toString(), new ColumnProcessor());
        if (code == null) {
            return "";
        }
        return code;
    }
    
    //辅助核算16 物料分类名称
    public static String getMarBasName(String pk) throws Exception{
        StringBuffer str = new StringBuffer();
        str.append("select name from bd_marbasclass where nvl(dr,0)=0 and pk_marbasclass = '"+pk+"'");
        String name = (String) iuap.executeQuery(str.toString(), new ColumnProcessor());
        if (name == null) {
            return "";
        }
        return name;
    }
    
    //辅助核算17 资产类别编码
    public static String getCategoryCode(String pk) throws Exception{
        StringBuffer str = new StringBuffer();
        str.append("select cate_code from fa_category where nvl(dr,0)=0 and pk_category = '"+pk+"'");
        String code = (String) iuap.executeQuery(str.toString(), new ColumnProcessor());
        if (code == null) {
            return "";
        }
        return code;
    }
    
    //辅助核算17 资产类别名称
    public static String getCategoryName(String pk) throws Exception{
        StringBuffer str = new StringBuffer();
        str.append("select cate_name from fa_category where nvl(dr,0)=0 and pk_category = '"+pk+"'");
        String name = (String) iuap.executeQuery(str.toString(), new ColumnProcessor());
        if (name == null) {
            return "";
        }
        return name;
    }
    
    //辅助核算18 供应商分类编码
    public static String getSupplierClassCode(String pk) throws Exception{
        StringBuffer str = new StringBuffer();
        str.append("select code from bd_supplierclass where nvl(dr,0)=0 and pk_supplierclass = '"+pk+"'");
        String code = (String) iuap.executeQuery(str.toString(), new ColumnProcessor());
        if (code == null) {
            return "";
        }
        return code;
    }
    
    //辅助核算18 供应商分类名称
    public static String getSupplierClassName(String pk) throws Exception{
        StringBuffer str = new StringBuffer();
        str.append("select name from bd_supplierclass where nvl(dr,0)=0 and pk_supplierclass = '"+pk+"'");
        String name = (String) iuap.executeQuery(str.toString(), new ColumnProcessor());
        if (name == null) {
            return "";
        }
        return name;
    }
}
